package com.pms.ocp.controller;


import com.pms.ocp.model.dto.ApiParamDTO;
import com.pms.ocp.model.dto.ApiTreeGroupDto;
import com.pms.ocp.model.dto.OcpApiGroupDtos;
import com.pms.ocp.model.entity.OcpApiGroup;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.OcpApiTreeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@Slf4j
@RequestMapping("/api-group/v1")
@RestController
@Api(tags = "服务树管理接口")
public class OcpApiTreeController {


    @Autowired
    private OcpApiTreeService service;

    /**
     * 服务树分类
     * @return
     */
    @GetMapping("/getTree")
    @ApiOperation("服务树分类")
    public ApiTreeGroupDto getTree(){
        ApiTreeGroupDto byGroup = service.getByGroup();
        return byGroup;
    }


    @PostMapping("/instertree")
    @ApiOperation("服务树分类--新增")
    public ResponseVO inseter(@RequestBody OcpApiGroupDtos ocpApiGroupDtos){
        service.insertTree(ocpApiGroupDtos);
            return ResponseVO.ok();
    }
    @PostMapping("/updatatree")
    @ApiOperation("服务树分类--修改")
    public ResponseVO updataTree(@RequestBody OcpApiGroup ocpApiGroup){
        service.updataOcpTree(ocpApiGroup);
        return ResponseVO.ok();
    }
    @PostMapping("/deletetree")
    @ApiOperation("服务树分类--删除")
    public ResponseVO deleteTree(@RequestBody OcpApiGroup ocpApiGroup){
        boolean tree = service.deleteOcpTree(ocpApiGroup);
        if (tree){
            return ResponseVO.ok();
        }else {
            return ResponseVO.error("请先删除下级目录");
        }

    }








}
